#!/usr/bin/python

from machine import UART,Pin
import time

ser = UART(0)
ser.read(ser.any())

power_key = 2
command_input = ''
rec_buff = ''

def power_on(power_key):
    print('SIM7600X is starting:')
    P=Pin(power_key,Pin.OUT)
    time.sleep(0.1)
    P.value(1)
    time.sleep(2)
    P.value(0)
    time.sleep(20)
    ser.read(ser.any())
    print('SIM7600X is ready')

def power_down(power_key):
    P=Pin(power_key,Pin.OUT)
    print('SIM7600X is loging off:')
    P.value(1)
    time.sleep(3)
    P.value(0)
    time.sleep(18)
    print('Good bye')
try:
    power_on(power_key)
    while True:
        command_input = input('Please input the AT command:')
        ser.write((command_input+  '\r\n' ).encode())
        time.sleep(0.1)
        if ser.any():
            time.sleep(0.01)
            rec_buff = ser.read(ser.any())
        if rec_buff != '':
            print(rec_buff.decode())
            rec_buff = ''
except:
    ser.deinit()
    power_down(power_key)