#!/usr/bin/python
# -*- coding:utf-8 -*-
from machine import UART,Pin
import time

ser = UART(0)
ser.read(ser.any())

power_key = 2
rec_buff = ''
rec_buff2 = ''
time_count = 0

def send_at(command,back,timeout):
    rec_buff = ''
    ser.write((command+'\r\n').encode())
    time.sleep(timeout)
    if ser.any():
        time.sleep(0.01 )
        rec_buff = ser.read(ser.any())
    if rec_buff != '':
        if back not in rec_buff.decode():
            print(command + ' ERROR')
            print(command + ' back:\t' + rec_buff.decode())
            return 0
        else:
            print(rec_buff.decode())
            return 1
    else:
        print('GPS is not ready')
        return 0

def get_gps_position():
    rec_null = True
    answer = 0
    print('Start GPS session...')
    rec_buff = ''
    send_at('AT+CGPS=1,1','OK',1)
    time.sleep(2)
    while rec_null:
        answer = send_at('AT+CGPSINFO','+CGPSINFO: ',1)
        if 1 == answer:
            answer = 0
            if ',,,,,,' in rec_buff:
                print('GPS is not ready')
                rec_null = False
                time.sleep(1)
        else:
            print('error %d'%answer)
            rec_buff = ''
            send_at('AT+CGPS=0','OK',1)
            return False
        time.sleep(1.5)


def power_on(power_key):
    print('SIM7600X is starting:')
    P=Pin(power_key,Pin.OUT)
    time.sleep(0.1)
    P.value(1)
    time.sleep(2)
    P.value(0)
    time.sleep(20)
    ser.read(ser.any())
    print('SIM7600X is ready')

def power_down(power_key):
    P=Pin(power_key,Pin.OUT)
    print('SIM7600X is loging off:')
    P.value(1)
    time.sleep(3)
    P.value(0)
    time.sleep(18)
    print('Good bye')

try:
    power_on(power_key)
    get_gps_position()
    power_down(power_key)
except:
    if ser != None:
        ser.deinit()
    power_down(power_key)
if ser != None:
        ser.deinit()